@file:Suppress("unused")

package net.sergeych.tools

import kotlinx.coroutines.cancel
import kotlinx.coroutines.coroutineScope
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.launch

/**
 * suspend until the flow produces the value to which the
 * predicate returns true
 */
suspend fun <T>Flow<T>.waitFor(predicate: (T)->Boolean) {
    coroutineScope {
        launch {
            collect {
                if( predicate(it) ) cancel()
            }
        }
    }
}